var path = require("path"); 
var fs = require("fs");
var url = require("url");
var hlp = require('../helper');

function handleDefault(_req, _res, _next, _logger, _config) {
	var parts = url.parse(_req.url);
	var origFilePath = unescape(path.normalize('.' + parts.pathname));
    var binDir = require('path').dirname(require.main.filename);
    filePath = path.resolve(binDir, _config.webRootFolder, origFilePath);

	function reportError(err) {
		_logger.log('error', err);
		_res.writeHead(500);
		_res.end('Internal Server Error');
	}

	fs.exists(filePath, (exists) => {
		if (exists) {
			fs.stat(filePath, (err, stat) => {
				var rs;
				if (err) {
					return reportError(err);
				}
				if (stat.isDirectory()) {
					_res.writeHead(403); 
					_res.end('Forbidden');
				} else {
					var msg = '[' + 
						hlp.formatIP(_req.connection.remoteAddress) + ':' + 
						_req.connection.remotePort + '] Default: Serving ' + 
						origFilePath;
					_logger.log('info', msg);
					rs = fs.createReadStream(filePath);
					rs.on('error', reportError);
					_res.writeHead(200, 'text/plain');
					rs.pipe(_res);
				}
			});
		} else	{
			_res.writeHead(404);
			_res.end(origFilePath + ' not found');
			_logger.log('error', 'Default: ' + origFilePath + ' not found');
		}
	});
}

exports.handle = function(_logger, _config) {
	return function(_req, _res, _next) {
		handleDefault(_req, _res, _next, _logger, _config);
	}
};